// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AO64C/16AO64C_Linux_1.x.x.x.GSC_DN/driver/16ao64c.h $
// $Rev: 53038 $
// $Date: 2023-05-18 15:57:30 -0500 (Thu, 18 May 2023) $

// 16AO64C: Device Driver: header file

#ifndef	__16AO64C_H__
#define	__16AO64C_H__

#include "gsc_common.h"
#include "gsc_pci9056.h"



// macros *********************************************************************

#define	AO64C_BASE_NAME						"16ao64c"

// IOCTL command codes
#define	AO64C_IOCTL_REG_READ				OS_IOCTL_RW( 0, 12, gsc_reg_t)
#define	AO64C_IOCTL_REG_WRITE				OS_IOCTL_W ( 1, 12, gsc_reg_t)
#define	AO64C_IOCTL_REG_MOD					OS_IOCTL_W ( 2, 12, gsc_reg_t)
#define	AO64C_IOCTL_QUERY					OS_IOCTL_RW( 3,  4, s32)
#define	AO64C_IOCTL_INITIALIZE				OS_IOCTL   ( 4)
#define	AO64C_IOCTL_AUTOCAL					OS_IOCTL   ( 5)
#define	AO64C_IOCTL_AUTOCAL_STATUS			OS_IOCTL_R ( 6,  4, s32)
#define	AO64C_IOCTL_BUFFER_CLEAR			OS_IOCTL   ( 7)
#define	AO64C_IOCTL_BUFFER_LEVEL			OS_IOCTL_RW( 8,  4, s32)
#define	AO64C_IOCTL_BUFFER_MODE				OS_IOCTL_RW( 9,  4, s32)
#define	AO64C_IOCTL_BUFFER_OVER_DATA		OS_IOCTL_RW(10,  4, s32)
#define	AO64C_IOCTL_BUFFER_OVER_FRAME		OS_IOCTL_RW(11,  4, s32)
#define	AO64C_IOCTL_BUFFER_STATUS			OS_IOCTL_R (12,  4, s32)
#define	AO64C_IOCTL_BUFFER_THRESH_LVL		OS_IOCTL_RW(13,  4, s32)
#define	AO64C_IOCTL_BUFFER_THRESH_STS		OS_IOCTL_R (14,  4, s32)
#define	AO64C_IOCTL_BURST_ENABLE			OS_IOCTL_RW(15,  4, s32)
#define	AO64C_IOCTL_BURST_READY				OS_IOCTL_R (16,  4, s32)
#define	AO64C_IOCTL_BURST_TRIGGER			OS_IOCTL   (17)
#define	AO64C_IOCTL_BURST_TRIG_SRC			OS_IOCTL_RW(18,  4, s32)
#define	AO64C_IOCTL_CLOCK_ENABLE			OS_IOCTL_RW(19,  4, s32)
#define	AO64C_IOCTL_CLOCK_MODE				OS_IOCTL_RW(20,  4, s32)
#define	AO64C_IOCTL_CLOCK_READY				OS_IOCTL_R (21,  4, s32)
#define	AO64C_IOCTL_CLOCK_SRC				OS_IOCTL_RW(22,  4, s32)
#define	AO64C_IOCTL_CLOCK_SW				OS_IOCTL   (23)
#define	AO64C_IOCTL_DATA_FORMAT				OS_IOCTL_RW(24,  4, s32)
#define	AO64C_IOCTL_GROUND_SENSE			OS_IOCTL_RW(25,  4, s32)
#define	AO64C_IOCTL_IRQ_SEL					OS_IOCTL_RW(26,  4, s32)
#define	AO64C_IOCTL_LOAD_READY				OS_IOCTL_R (27,  4, s32)
#define	AO64C_IOCTL_LOAD_REQUEST			OS_IOCTL   (28)
#define	AO64C_IOCTL_OUTPUT_DISCONNECT		OS_IOCTL_RW(29,  4, s32)
#define	AO64C_IOCTL_RAG_ENABLE				OS_IOCTL_RW(30,  4, s32)
#define	AO64C_IOCTL_RAG_NRATE				OS_IOCTL_RW(31,  4, s32)
#define	AO64C_IOCTL_RANGE					OS_IOCTL_RW(32,  4, s32)
#define	AO64C_IOCTL_RBG_ENABLE				OS_IOCTL_RW(33,  4, s32)
#define	AO64C_IOCTL_RBG_NRATE				OS_IOCTL_RW(34,  4, s32)
#define	AO64C_IOCTL_TRIGGER_MODE			OS_IOCTL_RW(35,  4, s32)
#define	AO64C_IOCTL_TX_IO_ABORT				OS_IOCTL_R (36,  4, s32)
#define	AO64C_IOCTL_TX_IO_MODE				OS_IOCTL_RW(37,  4, s32)
#define	AO64C_IOCTL_TX_IO_OVER_DATA			OS_IOCTL_RW(38,  4, s32)
#define	AO64C_IOCTL_TX_IO_OVER_FRAME		OS_IOCTL_RW(39,  4, s32)
#define	AO64C_IOCTL_TX_IO_TIMEOUT			OS_IOCTL_RW(40,  4, s32)
#define	AO64C_IOCTL_WAIT_CANCEL				OS_IOCTL_RW(41, 28, gsc_wait_t)
#define	AO64C_IOCTL_WAIT_EVENT				OS_IOCTL_RW(42, 28, gsc_wait_t)
#define	AO64C_IOCTL_WAIT_STATUS				OS_IOCTL_RW(43, 28, gsc_wait_t)
#define	AO64C_IOCTL_TX_IO_BYTE_SWAP			OS_IOCTL_RW(44,  4, s32)

//*****************************************************************************
// AO64C_IOCTL_REG_READ
// AO64C_IOCTL_REG_WRITE
// AO64C_IOCTL_REG_MOD
//
#define	AO64C_REG_ENCODE(s,o)				GSC_REG_ENCODE(GSC_REG_TYPE_BAR2,(s),(o))
// Parameter:	gsc_reg_t*
#define	AO64C_GSC_BCR						AO64C_REG_ENCODE(4,0x00)// Board Control Register
#define	AO64C_GSC_BOR						AO64C_REG_ENCODE(4,0x0C)// Buffer Operations Register
#define	AO64C_GSC_ACR						AO64C_REG_ENCODE(4,0x10)// Assembly Configuration Register
#define	AO64C_GSC_AVR						AO64C_REG_ENCODE(4,0x14)// Autocal Values Register
#define	AO64C_GSC_ODBR						AO64C_REG_ENCODE(4,0x18)// Output Data Buffer Register
#define	AO64C_GSC_BSR						AO64C_REG_ENCODE(4,0x1C)// Buffer Size Register
#define	AO64C_GSC_BTR						AO64C_REG_ENCODE(4,0x20)// Buffer Threshold Register
#define	AO64C_GSC_RAGR						AO64C_REG_ENCODE(4,0x24)// Rate-A Generator Register
#define	AO64C_GSC_RBGR						AO64C_REG_ENCODE(4,0x28)// Rate-B Generator Register

//*****************************************************************************
// AO64C_IOCTL_QUERY
//
//	Parameter:	s32
//		Pass in a value from the list below.
//		The value returned is the answer to the query.

typedef enum
{
	AO64C_QUERY_AUTOCAL_MS,		// Max autocalibrate period in ms.
	AO64C_QUERY_CHANNEL_MAX,	// Maximum number of channels supported.
	AO64C_QUERY_CHANNEL_QTY,	// The number of A/D channels.
	AO64C_QUERY_COUNT,			// Number of query options.
	AO64C_QUERY_DEVICE_TYPE,	// Value from gsc_dev_type_t
	AO64C_QUERY_DIFFERENTIAL,	// Differential outputs? (else single ended)
	AO64C_QUERY_DISCONNECT,		// Is Output Disconnect feature present?
	AO64C_QUERY_FIFO_SIZE,		// FIFO depth in 32-bit samples
	AO64C_QUERY_FILTER,			// See filter options below.
	AO64C_QUERY_FREF_DEFAULT,	// The default Fref value for the device.
	AO64C_QUERY_FSAMP_MAX,		// Rate Generator maximum output rate.
	AO64C_QUERY_FSAMP_MIN,		// Rate Generator minimum output rate.
	AO64C_QUERY_INIT_MS,		// Max initialize period in ms.
	AO64C_QUERY_NRATE_MASK,		// Mask of valid Nrate bits.
	AO64C_QUERY_NRATE_MAX,		// Maximum rate generator Nrate value.
	AO64C_QUERY_NRATE_MIN,		// Maximum rate generator Nrate value.
	AO64C_QUERY_RANGE,			// See voltage range options below.
	AO64C_QUERY_LAST			// Must be very last entry.

} ao64c_query_t;

#define	AO64C_IOCTL_QUERY_ERROR	(-1)	// A query request is unknown or invalid.

// AO64C_QUERY_FILTER options.				ACR D20-D21
#define	AO64C_FILTER_100KHZ					0
#define	AO64C_FILTER_10KHZ					1
#define	AO64C_FILTER_NONE					2

// AO64C_QUERY_RANGE options:				ACR D18-D19
#define	AO64C_RANGE_UNI_10_5				0
#define	AO64C_RANGE_BI_10_5					1

//*****************************************************************************
// AO64C_IOCTL_INITIALIZE					BCR D15
//
//	Parameter:	None

//*****************************************************************************
// AO64C_IOCTL_AUTOCAL						BCR D13
//
//	Parameter:	None

// This is retained for backwards compatibility
#define	AO64C_IOCTL_AUTO_CALIBRATE			AO64C_IOCTL_AUTOCAL

//*****************************************************************************
// AO64C_IOCTL_AUTOCAL_STATUS				BCR D13, D14
//
//	Parameter:	s32*
//		One of the below values is returned.
#define	AO64C_AUTOCAL_STATUS_ACTIVE			0
#define	AO64C_AUTOCAL_STATUS_FAIL			1
#define	AO64C_AUTOCAL_STATUS_PASS			2

// These are retained for backwards compatibility
#define	AO64C_IOCTL_AUTO_CAL_STS			AO64C_IOCTL_AUTOCAL_STATUS
#define	AO64C_AUTO_CAL_STS_ACTIVE			AO64C_AUTOCAL_STATUS_ACTIVE
#define	AO64C_AUTO_CAL_STS_FAIL				AO64C_AUTOCAL_STATUS_FAIL
#define	AO64C_AUTO_CAL_STS_PASS				AO64C_AUTOCAL_STATUS_PASS

//*****************************************************************************
// AO64C_IOCTL_BUFFER_CLEAR					BOR D11, D16, D17
//	The driver will wait the write timeout for completion.
//
//	Parameter:	None.

//*****************************************************************************
// AO64C_IOCTL_BUFFER_LEVEL					BSR D0-D18
//
//	Parameter:	s32
//		The driver will return a value between zero and 0x40000.

//*****************************************************************************
// AO64C_IOCTL_BUFFER_MODE					BOR D8
//
//	Parameter:	s32
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AO64C_BUFFER_MODE_OPEN				0
#define	AO64C_BUFFER_MODE_CIRC				1

//*****************************************************************************
// AO64C_IOCTL_BUFFER_OVER_DATA				BOR D16
//
//	Parameter:	s32
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AO64C_BUFFER_OVER_DATA_CLR			0
#define	AO64C_BUFFER_OVER_DATA_CHK			(-1)

//		The service returns one of the below listed values.
#define	AO64C_BUFFER_OVER_DATA_NO			0
#define	AO64C_BUFFER_OVER_DATA_YES			1

//*****************************************************************************
// AO64C_IOCTL_BUFFER_OVER_FRAME			BOR D17
//
//	Parameter:	s32
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AO64C_BUFFER_OVER_FRAME_CLR			0
#define	AO64C_BUFFER_OVER_FRAME_CHK			(-1)

//		The service returns one of the below listed values.
#define	AO64C_BUFFER_OVER_FRAME_NO			0
#define	AO64C_BUFFER_OVER_FRAME_YES			1

//*****************************************************************************
// AO64C_IOCTL_BUFFER_STATUS				BOR D12, D15, BTR D0-D18, D20
//
//	Parameter:	s32
//		The service returns one of the below listed values.
#define	AO64C_BUFFER_STATUS_EMPTY			0
#define	AO64C_BUFFER_STATUS_LOW				1	// <= threshold level
#define	AO64C_BUFFER_STATUS_HIGH			2	// > threshold level
#define	AO64C_BUFFER_STATUS_FULL			3

//*****************************************************************************
// AO64C_IOCTL_BUFFER_THRESH_LVL			BTR D0-D18
//
//	Parameter:	s32
//		Pass in any valid value, or
//		-1 to read the current setting.
//		The valid range is 0 to 0x7FFFF.

//*****************************************************************************
// AO64C_IOCTL_BUFFER_THRESH_STS			BTR D20, BCR D12
//
//	Parameter:	s32*
//		The returned value is one of the below options.
#define	AO64C_BUFFER_THRESH_STS_CLR			0
#define	AO64C_BUFFER_THRESH_STS_SET			1

//*****************************************************************************
// AO64C_IOCTL_BURST_ENABLE					BOR D2
//
//	Parameter:	s32
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AO64C_BURST_ENABLE_NO				0
#define	AO64C_BURST_ENABLE_YES				1

//*****************************************************************************
// AO64C_IOCTL_BURST_READY					BOR D3
//
//	Parameter:	s32
//		The service returns one of the below listed values.
#define	AO64C_BURST_READY_NO				0
#define	AO64C_BURST_READY_YES				1

//*****************************************************************************
// AO64C_IOCTL_BURST_TRIGGER				BOR D4
//	The driver will wait the write timeout for completion.
//
//	Parameter:	None.

//*****************************************************************************
// AO64C_IOCTL_BURST_TRIG_SRC				BOR D1
//
//	Parameter:	s32
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AO64C_BURST_TRIG_SRC_RBG			0	// Rate-B Generator
#define	AO64C_BURST_TRIG_SRC_EXT			1

//*****************************************************************************
// AO64C_IOCTL_CLOCK_ENABLE					BOR D5
//
//	Parameter:	s32
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AO64C_CLOCK_ENABLE_NO				0
#define	AO64C_CLOCK_ENABLE_YES				1

//*****************************************************************************
// AO64C_IOCTL_CLOCK_MODE					BCR D0
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AO64C_CLOCK_MODE_TARGET				0
#define	AO64C_CLOCK_MODE_INITIATOR			1

//*****************************************************************************
// AO64C_IOCTL_CLOCK_READY					BOR D6
//
//	Parameter:	s32
//		The service returns one of the below listed values.
#define	AO64C_CLOCK_READY_NO				0
#define	AO64C_CLOCK_READY_YES				1

//*****************************************************************************
// AO64C_IOCTL_CLOCK_SRC					BOR D0
//
//	Parameter:	s32
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AO64C_CLOCK_SRC_RAG					0
#define	AO64C_CLOCK_SRC_EXT					1

//*****************************************************************************
// AO64C_IOCTL_CLOCK_SW						BOR D7
//	The driver will wait the write timeout for completion.
//
//	Parameter:	None.

//*****************************************************************************
// AO64C_IOCTL_DATA_FORMAT					BCR D4
//
//	Parameter:	s32
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AO64C_DATA_FORMAT_2S_COMP			0	// Twos Compliment
#define	AO64C_DATA_FORMAT_OFF_BIN			1	// Offset Binary

//*****************************************************************************
// AO64C_IOCTL_GROUND_SENSE					BCR D3
//
//	Parameter:	s32
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AO64C_GROUND_SENSE_DISABLE			0
#define	AO64C_GROUND_SENSE_REMOTE			1

//*****************************************************************************
// AO64C_IOCTL_IRQ_SEL						BCR D8-D10, D11
//
//	Parameter:	s32
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AO64C_IRQ_INIT_DONE					0
#define	AO64C_IRQ_AUTOCAL_DONE				1
#define	AO64C_IRQ_BUF_EMPTY					2
#define	AO64C_IRQ_BUF_THRESH_LO2HI			3
#define	AO64C_IRQ_BUF_THRESH_HI2LO			4
#define	AO64C_IRQ_BURST_TRIG_READY			5
#define	AO64C_IRQ_LOAD_READY				6
#define	AO64C_IRQ_LOAD_READY_END			7

//*****************************************************************************
// AO64C_IOCTL_LOAD_READY					BOR D10
//
//	Parameter:	s32
//		The service returns one of the below listed values.
#define	AO64C_LOAD_READY_NO					0
#define	AO64C_LOAD_READY_YES				1

//*****************************************************************************
// AO64C_IOCTL_LOAD_REQUEST					BOR D9
//	The driver will wait the write timeout for completion.
//
//	Parameter:	None

//*****************************************************************************
// AO64C_IOCTL_OUTPUT_DISCONNECT			BCR D2
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
//		The value -1 is returned if the option is unavailable.
#define	AO64C_OUTPUT_DISCONNECT_NO			0
#define	AO64C_OUTPUT_DISCONNECT_YES			1

//*****************************************************************************
// AO64C_IOCTL_RAG_ENABLE					BCR D5
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AO64C_RAG_ENABLE_NO					0
#define	AO64C_RAG_ENABLE_YES				1

//*****************************************************************************
// AO64C_IOCTL_RAG_NRATE					RAGR D0-D23
// AO64C_IOCTL_RBG_NRATE					RBGR D0-D23
//
//	Parameter:	s32
//		Pass in any valid value, or
//		-1 to read the current setting.
//		The valid range is 98 to 0xFFFFFF.

//*****************************************************************************
// AO64C_IOCTL_RANGE						BCR D16
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AO64C_RANGE_10V						0	// 0-10, +-10
#define	AO64C_RANGE_5V						1	// 0-5, +-5

//*****************************************************************************
// AO64C_IOCTL_RBG_ENABLE					BCR D6
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AO64C_RBG_ENABLE_NO					0
#define	AO64C_RBG_ENABLE_YES				1

//*****************************************************************************
// AO64C_IOCTL_TRIGGER_MODE					BCR D1
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AO64C_TRIGGER_MODE_TARGET			0
#define	AO64C_TRIGGER_MODE_INITIATOR		1

//*****************************************************************************
// AO64C_IOCTL_TX_IO_ABORT
//
//	Parameter:	s32*
//		The returned value is one of the below options.
#define	AO64C_IO_ABORT_NO					0
#define	AO64C_IO_ABORT_YES					1

//*****************************************************************************
// AO64C_IOCTL_TX_IO_MODE
//
//	Parameter:	s32
//		Pass in any of the gsc_io_mode_t options, or
//		-1 to read the current setting.
#define	AO64C_IO_MODE_DEFAULT				GSC_IO_MODE_PIO

//*****************************************************************************
// AO64C_IOCTL_TX_IO_OVER_DATA
//
//	Parameter:	s32
//		Pass in any valid value, or
//		-1 to read the current setting.
#define	AO64C_TX_IO_OVER_DATA_IGNORE		0
#define	AO64C_TX_IO_OVER_DATA_CHECK			1
#define	AO64C_TX_IO_OVER_DATA_DEFAULT		AO64C_TX_IO_OVER_DATA_CHECK

//*****************************************************************************
// AO64C_IOCTL_TX_IO_OVER_FRAME
//
//	Parameter:	s32
//		Pass in any valid value, or
//		-1 to read the current setting.
#define	AO64C_TX_IO_OVER_FRAME_IGNORE		0
#define	AO64C_TX_IO_OVER_FRAME_CHECK		1
#define	AO64C_TX_IO_OVER_FRAME_DEFAULT		AO64C_TX_IO_OVER_FRAME_CHECK

//*****************************************************************************
// AO64C_IOCTL_TX_IO_TIMEOUT (in seconds)
//
//	Parameter:	s32
//		Pass in any value from the minimim to the maximim, the infinite option,
//		or -1 to read the current setting. The value -1 is returned if the
//		feature is not supported, but this should never happen.
#define	AO64C_IO_TIMEOUT_DEFAULT			10
#define	AO64C_IO_TIMEOUT_NO_SLEEP			0		// Do not sleep to wait for more data.
#define	AO64C_IO_TIMEOUT_MIN				0
#define	AO64C_IO_TIMEOUT_MAX				GSC_IO_TIMEOUT_MAX
#define	AO64C_IO_TIMEOUT_INFINITE			GSC_IO_TIMEOUT_INFINITE

//*****************************************************************************
// AO64C_IOCTL_WAIT_EVENT					all fields must be valid
// AO64C_IOCTL_WAIT_CANCEL					fields need not be valid
// AO64C_IOCTL_WAIT_STATUS					fields need not be valid
//
//	Parameter:	gsc_wait_t*
// gsc_wait_t.flags - see gsc_common.h
// gsc_wait_t.main - see gsc_common.h
// gsc_wait_t.gsc
#define	AO64C_WAIT_GSC_INIT_DONE			0x0001
#define	AO64C_WAIT_GSC_AUTOCAL_DONE			0x0002
#define	AO64C_WAIT_GSC_BUF_EMPTY			0x0004
#define	AO64C_WAIT_GSC_BUF_THRESH_LO2HI		0x0008
#define	AO64C_WAIT_GSC_BUF_THRESH_HI2LO		0x0010
#define	AO64C_WAIT_GSC_BURST_TRIG_READY		0x0020
#define	AO64C_WAIT_GSC_LOAD_READY			0x0040
#define	AO64C_WAIT_GSC_LOAD_READY_END		0x0080
#define	AO64C_WAIT_GSC_ALL					0x00FF
// gsc_wait_t.alt flags
#define	AO64C_WAIT_ALT_ALL					0x0000
// gsc_wait_t.io
#define	AO64C_WAIT_IO_TX_ABORT				0x0001
#define	AO64C_WAIT_IO_TX_DONE				0x0002
#define	AO64C_WAIT_IO_TX_ERROR				0x0004
#define	AO64C_WAIT_IO_TX_TIMEOUT			0x0008
#define	AO64C_WAIT_IO_ALL					0x000F

//*****************************************************************************
// AO64C_IOCTL_TX_IO_BYTE_SWAP
//
//	Parameter:	s32
//		Pass in any valid value, or
//		-1 to read the current setting.
#define	AO64C_TX_IO_BYTE_SWAP_PERFORM		0
#define	AO64C_TX_IO_BYTE_SWAP_CHECK			1
#define	AO64C_TX_IO_BYTE_SWAP_DISABLE		2
#define	AO64C_TX_IO_BYTE_SWAP_DEFAULT		AO64C_TX_IO_BYTE_SWAP_PERFORM



#endif
