// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AO64C/16AO64C_Linux_1.x.x.x.GSC_DN/include/16ao64c_utils.h $
// $Rev: 53039 $
// $Date: 2023-05-18 15:58:06 -0500 (Thu, 18 May 2023) $

// 16AO64C: Utilities: header file

#ifndef	__16AO64C_UTILS_H__
#define	__16AO64C_UTILS_H__

#include "16ao64c_api.h"
#include "gsc_utils.h"
#include "gsc_utils_pci.h"



// prototypes *****************************************************************

// API utility services

int	ao64c_close_util			(int fd, int index, int verbose);
int ao64c_init_util				(int verbose);
int ao64c_ioctl_util			(int fd, int index, int verbose, int request, void* arg);
int	ao64c_open_util				(int device, int share, int index, int verbose, int* fd);
int ao64c_read_util				(int fd, int index, int verbose, void* dst, size_t bytes);
int	ao64c_write_util			(int fd, int index, int verbose, const void* src, size_t bytes);

// IOCTL utility services

int	ao64c_autocal				(int fd, int index, int verbose);								// AO64C_IOCTL_AUTOCAL
int	ao64c_autocal_status		(int fd, int index, int verbose, s32* get);						// AO64C_IOCTL_AUTOCAL_STATUS
int	ao64c_buffer_clear			(int fd, int index, int verbose);								// AO64C_IOCTL_BUFFER_CLEAR
int	ao64c_buffer_level			(int fd, int index, int verbose, s32* get);						// AO64C_IOCTL_BUFFER_LEVEL
int	ao64c_buffer_mode			(int fd, int index, int verbose, s32 set, s32* get);			// AO64C_IOCTL_BUFFER_MODE
int	ao64c_buffer_over_data		(int fd, int index, int verbose, s32 set, s32* get);			// AO64C_IOCTL_BUFFER_OVER_DATA
int	ao64c_buffer_over_frame		(int fd, int index, int verbose, s32 set, s32* get);			// AO64C_IOCTL_BUFFER_OVER_FRAME
int	ao64c_buffer_status			(int fd, int index, int verbose, s32* get);						// AO64C_IOCTL_BUFFER_STATUS
int	ao64c_buffer_thresh_lvl		(int fd, int index, int verbose, s32 set, s32* get);			// AO64C_IOCTL_BUFFER_THRESH_LVL
int	ao64c_buffer_thresh_sts		(int fd, int index, int verbose, s32* get);						// AO64C_IOCTL_BUFFER_THRESH_STS
int	ao64c_burst_enable			(int fd, int index, int verbose, s32 set, s32* get);			// AO64C_IOCTL_BURST_ENABLE
int	ao64c_burst_ready			(int fd, int index, int verbose, s32* get);						// AO64C_IOCTL_BURST_READY
int	ao64c_burst_trig_src		(int fd, int index, int verbose, s32 set, s32* get);			// AO64C_IOCTL_BURST_TRIG_SRC
int	ao64c_burst_trigger			(int fd, int index, int verbose);								// AO64C_IOCTL_BURST_TRIGGER
int	ao64c_clock_enable			(int fd, int index, int verbose, s32 set, s32* get);			// AO64C_IOCTL_CLOCK_ENABLE
int	ao64c_clock_mode			(int fd, int index, int verbose, s32 set, s32* get);			// AO64C_IOCTL_CLOCK_MODE
int	ao64c_clock_ready			(int fd, int index, int verbose, s32 set, s32* get);			// AO64C_IOCTL_CLOCK_READY
int	ao64c_clock_src				(int fd, int index, int verbose, s32 set, s32* get);			// AO64C_IOCTL_CLOCK_SRC
int	ao64c_clock_sw				(int fd, int index, int verbose);								// AO64C_IOCTL_CLOCK_SW
int	ao64c_data_format			(int fd, int index, int verbose, s32 set, s32* get);			// AO64C_IOCTL_DATA_FORMAT
int	ao64c_ground_sense			(int fd, int index, int verbose, s32 set, s32* get);			// AO64C_IOCTL_GROUND_SENSE
int	ao64c_initialize			(int fd, int index, int verbose);								// AO64C_IOCTL_INITIALIZE
int	ao64c_irq_sel				(int fd, int index, int verbose, s32 set, s32* get);			// AO64C_IOCTL_IRQ_SEL
int	ao64c_load_ready			(int fd, int index, int verbose, s32 set, s32* get);			// AO64C_IOCTL_LOAD_READY
int	ao64c_load_request			(int fd, int index, int verbose);								// AO64C_IOCTL_LOAD_REQUEST
int	ao64c_output_disconnect		(int fd, int index, int verbose, s32 set, s32* get);			// AO64C_IOCTL_OUTPUT_DISCONNECT
int	ao64c_query					(int fd, int index, int verbose, s32 set, s32* get);			// AO64C_IOCTL_QUERY
int	ao64c_rag_enable			(int fd, int index, int verbose, s32 set, s32* get);			// AO64C_IOCTL_RAG_ENABLE
int	ao64c_rag_nrate				(int fd, int index, int verbose, s32 set, s32* get);			// AO64C_IOCTL_RAG_NRATE
int	ao64c_range					(int fd, int index, int verbose, s32 set, s32* get);			// AO64C_IOCTL_RANGE
int	ao64c_rbg_enable			(int fd, int index, int verbose, s32 set, s32* get);			// AO64C_IOCTL_RBG_ENABLE
int	ao64c_rbg_nrate				(int fd, int index, int verbose, s32 set, s32* get);			// AO64C_IOCTL_RBG_NRATE
int	ao64c_reg_mod				(int fd, int index, int verbose, u32 reg, u32 val, u32 mask);	// AO64C_IOCTL_REG_MOD
int	ao64c_reg_read				(int fd, int index, int verbose, u32 reg, u32* val);			// AO64C_IOCTL_REG_READ
int	ao64c_reg_write				(int fd, int index, int verbose, u32 reg, u32 val);				// AO64C_IOCTL_REG_WRITE
int	ao64c_trigger_mode			(int fd, int index, int verbose, s32 set, s32* get);			// AO64C_IOCTL_TRIGGER_MODE
int	ao64c_tx_io_abort			(int fd, int index, int verbose, s32 set, s32* get);			// AO64C_IOCTL_TX_IO_ABORT
int	ao64c_tx_io_byte_swap		(int fd, int index, int verbose, s32 set, s32* get);			// AO64C_IOCTL_TX_IO_BYTE_SWAP
int	ao64c_tx_io_mode			(int fd, int index, int verbose, s32 set, s32* get);			// AO64C_IOCTL_TX_IO_MODE
int	ao64c_tx_io_over_data		(int fd, int index, int verbose, s32 set, s32* get);			// AO64C_IOCTL_TX_IO_OVER_DATA
int	ao64c_tx_io_over_frame		(int fd, int index, int verbose, s32 set, s32* get);			// AO64C_IOCTL_TX_IO_OVER_FRAME
int	ao64c_tx_io_timeout			(int fd, int index, int verbose, s32 set, s32* get);			// AO64C_IOCTL_TX_IO_TIMEOUT
int	ao64c_wait_cancel			(int fd, int index, int verbose, gsc_wait_t* wait);				// AO64C_IOCTL_WAIT_CANCEL
int	ao64c_wait_event			(int fd, int index, int verbose, gsc_wait_t* wait);				// AO64C_IOCTL_WAIT_EVENT
int	ao64c_wait_status			(int fd, int index, int verbose, gsc_wait_t* wait);				// AO64C_IOCTL_WAIT_STATUS

// Auxiliary utility services

int	ao64c_config_ao				(int fd, int index, int verbose, s32 fsamp, u64 map);
int	ao64c_fsamp_ao_compute		(int fd, int index, int verbose, s32 fsamp, s32* nrate, double* rate);
int	ao64c_fsamp_ao_get			(int fd, int index, int verbose, s32* fsamp);
int	ao64c_fsamp_ao_report		(int fd, int index, int verbose, int chan, s32* fsamp);
int	ao64c_fsamp_ao_report_all	(int fd, int index, int verbose, u64 map, s32* fsamp);
int	ao64c_id_device				(int fd, int index, int verbose);

int	ao64c_count_boards			(int verbose, s32* get);
int	ao64c_reg_list				(int fd, int detail);

const gsc_reg_def_t*			ao64c_reg_get_def_id(u32 reg);
const gsc_reg_def_t*			ao64c_reg_get_def_index(int index);
const char*						ao64c_reg_get_desc(u32 reg);
const char*						ao64c_reg_get_name(u32 reg);

// These are retained for backwards compatibility.
int	ao64c_auto_cal_sts			(int fd, int index, int verbose, s32* get);						// AO64C_IOCTL_AUTO_CAL_STS
int	ao64c_auto_calibrate		(int fd, int index, int verbose);								// AO64C_IOCTL_AUTO_CALIBRATE



#endif
