// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AO64C/16AO64C_Linux_1.x.x.x.GSC_DN/samples/id/perform.c $
// $Rev: 53043 $
// $Date: 2023-05-18 16:00:30 -0500 (Thu, 18 May 2023) $

// 16AO64C: Sample Application: source file

#include "main.h"



//*****************************************************************************
static void _rate_generators(void)
{
	gsc_label("Rate Generators");
	printf("2 (A and B)\n");
}



//*****************************************************************************
static void _clocking_sources(void)
{
	gsc_label("Clocking Sources");
	printf("Rate-A Generator, External, Software\n");
}



//*****************************************************************************
static void _trigger_sources(void)
{
	gsc_label("Trigger Sources");
	printf("Rate-B Generator, External, Software\n");
}



//*****************************************************************************
static void _operating_modes(void)
{
	gsc_label("Operating Modes");
	printf("Initiator and Target (independent for clock and trigger)\n");
}



//*****************************************************************************
static void _clocking_modes(void)
{
	gsc_label("Clocking Modes");
	printf("Continuous, Triggered Burst\n");

	gsc_label("Output Clocking");
	printf("Simultaneous\n");
}



//*****************************************************************************
static int _command_byte_placement(const args_t* args)
{
	u32	acr;
	int	errs	= 0;

	gsc_label("Command Byte Placement");
	errs	+= ao64c_reg_read(args->fd, -1, 0, AO64C_GSC_ACR, &acr);

	if ((acr & 0xFFFF) >= 0x0400)
		printf("byte 0xXX------ in output data\n");
	else
		printf("byte 0x--XX---- in output data <--- THIS FIRMWARE SHOULD BE UPDATED!\n");

	return(errs);
}



//*****************************************************************************
static int _id_device_acr(const args_t* args)
{
	int						errs;
	gsc_reg_def_t			list[2]	= { { NULL }, { NULL } };
	const gsc_reg_def_t*	ptr;

	printf("\n");
	ptr	= ao64c_reg_get_def_id(AO64C_GSC_ACR);

	if (ptr)
	{
		list[0]	= ptr[0];
		errs	= gsc_reg_list(args->fd, list, 1, ao64c_reg_read);
	}
	else
	{
		errs= 1;
		printf(	"FAIL <---  (%d. ao64c_reg_get_def_id, AO64C_GSC_ACR)\n",
				__LINE__);
	}

	return(errs);
}



//*****************************************************************************
static int _register_map(const args_t* args)
{
	int	errs;

	printf("\n");
	errs	= ao64c_reg_list(args->fd, args->detail);
	return(errs);
}



//*****************************************************************************
int perform_tests(const args_t* args)
{
	int	errs;
	int	i;

	gsc_label("Device Features");
	printf("\n");

	gsc_label_level_inc();

	_rate_generators();
	_clocking_sources();
	_clocking_modes();
	_trigger_sources();
	_operating_modes();

	errs	= _command_byte_placement(args);

	for (i = 0; i < AO64C_QUERY_LAST; i++)
		errs	+= ao64c_query(args->fd, -1, 1, i, NULL);

	gsc_label_level_dec();

	errs	+= _id_device_acr(args);
	errs	+= _register_map(args);
	printf("\n");

	return(errs);
}


