// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AO64C/16AO64C_Linux_1.x.x.x.GSC_DN/samples/mbsync/main.h $
// $Rev: 53044 $
// $Date: 2023-05-18 16:00:46 -0500 (Thu, 18 May 2023) $

// 16AO64C: Sample Application: header file

#ifndef	__MAIN_H__
#define	__MAIN_H__

#include "16ao64c_main.h"



// macros *********************************************************************

#define	SIZEOF_ARRAY(a)			(sizeof((a)) / sizeof((a)[0]))

#define	BOARD_QTY_MAX			9



// data types *****************************************************************

typedef struct
{
	// Application Settings

	s32	continuous;					// > 0 = ignore errors, < 0 = stop on errors
	s32	index[BOARD_QTY_MAX + 1];	// device indexes
	s32	minute_limit;
	int	qty;						// Number of devices detected.
	s32	seconds;					// Output data for this number of seconds.
	s32	test_limit;					// for continuous testing
	s32	unsync;						// Do not synchronize the devices.

	int	fd[BOARD_QTY_MAX + 1];		// File descriptor for device to access.

	// Device Settings

} args_t;



// prototypes *****************************************************************

int	perform_tests(const args_t* args);

int	service_close			(const args_t* args);
int	service_config_ao		(const args_t* args, const s32* chans, s32 fsamp);
int	service_id_device		(const args_t* args);
int	service_open			(const args_t* args, int* fd);
int	service_query_channels	(const args_t* args, s32* chans);
int	service_sample_rate		(const args_t* args, const s32* chans);


#endif
