// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AO64C/16AO64C_Linux_1.x.x.x.GSC_DN/samples/txrate/main.h $
// $Rev: 53052 $
// $Date: 2023-05-19 11:03:55 -0500 (Fri, 19 May 2023) $

// 16AO64C: Sample Application: header file

#ifndef	__MAIN_H__
#define	__MAIN_H__

#include <ctype.h>
#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <sys/timeb.h>

#include "16ao64c_main.h"



// macros *********************************************************************

#define	OUTPUT_MAP				0xFFFFFFFFFFFFFFFFULL	// 64 channels
#define	OUTPUT_RATE				500000L					// 32 channels or less
#define	SIZEOF_ARRAY(a)			(sizeof((a)) / sizeof((a)[0]))



// data types *****************************************************************

typedef struct
{
	// Application Settings

	s32	byte_swap;
	s32	continuous;		// > 0 = ignore errors, < 0 = stop on errors
	s32	index;			// device index
	s32	minute_limit;	// for continuous testing
	int	qty;			// Number of devices detected.
	s32	seconds;		// Tx data for this number of seconds.
	s32	test_limit;		// for continuous testing
	s32	tx_mb;
	s32	width;			// The full width of the square wave.

	int	fd;				// File descriptor for device to access.

	// Device Settings

	s32	io_mode;
} args_t;



// prototypes *****************************************************************

int	perform_tests(const args_t* args);



#endif
