// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AO64C/16AO64C_Linux_1.x.x.x.GSC_DN/utils/util_burst_trigger.c $
// $Rev: 44878 $
// $Date: 2019-05-13 14:59:33 -0500 (Mon, 13 May 2019) $

// 16AO64C: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	ao64c_burst_trigger
*
*	Purpose:
*
*		Provide a visual wrapper for the AO64C_IOCTL_BURST_TRIGGER service.
*
*	Arguments:
*
*		fd		Use this handle to access the device.
*
*		index	The index of the device to access. Ignore if < 0.
*				This is for display purposes only.
*
*		verbose	Work verbosely?
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int ao64c_burst_trigger(int fd, int index, int verbose)
{
	int	errs;
	int	ret;

	if (verbose)
		gsc_label_index("Burst Trigger", index);

	ret		= ao64c_ioctl(fd, AO64C_IOCTL_BURST_TRIGGER, NULL);
	errs	= ret ? 1 : 0;

	if (verbose)
		printf("%s\n", errs ? "FAIL <---" : "PASS");

	return(errs);
}


